#!/bin/sh

sl=$1
sl_code=$2
tl=$3
tl_code=$4
dir=$5

die () {
	echo >&2 "$@"
	exit 1
}

[ "$#" -eq 5 ] || die "Usage: ./tinylex.sh <SL Language> <SL Language Code> <TL Language> <TL Language Code> <DIX Directory>"

echo "Constructing tab file for $sl - $tl..."
mkdir $sl-$tl
cat $dir/sltl* | sort | uniq | sed '/@size/d' | sed 's/^\[//' | sed 's/]/\t/' | sed 's/\?/ /g' | sed 's/:[^:]*;\$//g' | sed 's/:[^:]*;/, /g' | sed 's/vblex.//g' | sed 's/:/: /g' | sed 's/  / /g' > $sl-$tl/$sl-$tl.tab
echo "Building OPF..."
cd $sl-$tl
../tab2opf.py $sl-$tl.tab > /dev/null
echo "Setting language metadata..."
sed "s/<dc:Language>EN<\/dc:Language>/<dc:Language>$sl_code<\/dc:Language>/" $sl-$tl.opf > $sl-$tl.opf.tmp
sed "s/<DictionaryInLanguage>en-us<\/DictionaryInLanguage>/<DictionaryInLanguage>$sl_code<\/DictionaryInLanguage>/" $sl-$tl.opf.tmp > $sl-$tl.opf
sed "s/<DictionaryOutLanguage>en-us<\/DictionaryOutLanguage>/<DictionaryOutLanguage>$tl_code<\/DictionaryOutLanguage>/" $sl-$tl.opf > $sl-$tl.opf.tmp
mv $sl-$tl.opf.tmp $sl-$tl.opf
echo "Compiling Kindle dictionary..."
kindlegen $sl-$tl.opf
cd ..
echo "Completed $sl - $tl.\n"

echo "Constructing tab file for $tl - $sl..."
mkdir $tl-$sl
cat $dir/tlsl* | sort | uniq | sed '/@size/d' | sed 's/^\[//' | sed 's/]/\t/' | sed 's/\?/ /g' | sed 's/:[^:]*;\$//g' | sed 's/:[^:]*;/, /g' | sed 's/vblex.//g' | sed 's/:/: /g' | sed 's/  / /g' > $tl-$sl/$tl-$sl.tab
echo "Building OPF..."
cd $tl-$sl
../tab2opf.py $tl-$sl.tab > /dev/null
echo "Setting language metadata..."
sed "s/<dc:Language>EN<\/dc:Language>/<dc:Language>$tl_code<\/dc:Language>/" $tl-$sl.opf > $tl-$sl.opf.tmp
sed "s/<DictionaryInLanguage>en-us<\/DictionaryInLanguage>/<DictionaryInLanguage>$tl_code<\/DictionaryInLanguage>/" $tl-$sl.opf.tmp > $tl-$sl.opf
sed "s/<DictionaryOutLanguage>en-us<\/DictionaryOutLanguage>/<DictionaryOutLanguage>$sl_code<\/DictionaryOutLanguage>/" $tl-$sl.opf > $tl-$sl.opf.tmp
mv $tl-$sl.opf.tmp $tl-$sl.opf
echo "Compiling Kindle dictionary..."
kindlegen $tl-$sl.opf
cd ..
echo "Completed $tl - $sl.\n"
